Attribute VB_Name = "GLOB"
Option Explicit
 Dim P_dCalculatorMatrix As D3DMATRIX
 Dim PIFactor As Single

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Global Const MAX_LIGHTS = 32
' The number Pi
Public Const PI As Double = 3.14159265358979
Public Const PIdiv180 = PI / 180
Public Const RAD = PI / 180

Public Type KAM
  CAMa As D3DVECTOR
  Cam_to As D3DVECTOR
  DEG As Double
  Angy As Double
End Type

Public Type world
  width As Double
  DEFT As Double
  Left_ As Double
  Bas As Double
  
End Type



Type JohVECTOR
   X As Single
   Y As Single
   Z As Single


End Type

Public Type LightType
 Active As Boolean
 Enabled As Boolean
 Light As D3DLIGHT7
End Type

Public Light(MAX_LIGHTS) As LightType

Public Type MaterialType
 Active As Boolean
 Enabled As Boolean
 Material As D3DMATERIAL7
End Type

'Public ParticuleDescription


Public Material(100) As MaterialType






Public Mat As D3DMATRIX
Public matWorld As D3DMATRIX
Public POSI As KAM
Public MONDE As world

Public Type Terrain_2
  vert() As D3DLVERTEX
  Index() As Integer
  Text_surf As DirectDrawSurface7
  NBvert As Long
  NBindex As Long
End Type




Public Type Drect
   Left As Single
   Top As Single
   Right As Single
   Bottom As Single
   Down As Single
   Up As Single



End Type

















Public Const MAX_ship = 10



'Global PlanE As New cPlane
Global USE_KAM As Boolean
Global GUN() As D3DVERTEX
Public GUN_indice As Long
Dim GUN_TEX As DirectDrawSurface7

Public Ci As Long



Public Function VICTOR(A As Single, B As Single, C As Single) As D3DVECTOR
    Dim vecOut As D3DVECTOR
    
    With vecOut
        .X = A
        .Y = B
        .Z = C
    End With
    
    VICTOR = vecOut
    
End Function
Function Vector(X, Y, Z) As D3DVECTOR

    Vector.X = X
    Vector.Y = Y
    Vector.Z = Z

End Function

Function VlenghtABS(v As D3DVECTOR)
   VlenghtABS = Sqr(v.X * v.X) + _
  (v.Y * v.Y) + Sqr(v.Z * v.Z)

End Function

Function Vlenght2(v As D3DVECTOR)
   Vlenght2 = (v.X * v.X) + _
  (v.Y * v.Y) + (v.Z * v.Z)

End Function

Function VectorRADtoDEG(Vec As D3DVECTOR) As D3DVECTOR
     VectorRADtoDEG.X = Vec.X / RAD
     VectorRADtoDEG.Y = Vec.Y / RAD
     VectorRADtoDEG.Z = Vec.Z / RAD
     
End Function

Function VectorDEGtoRAD(Vec As D3DVECTOR) As D3DVECTOR
     VectorDEGtoRAD.X = Vec.X * RAD
     VectorDEGtoRAD.Y = Vec.Y * RAD
     VectorDEGtoRAD.Z = Vec.Z * RAD
     
End Function

Function Vector_Dir(yaw, pitch) As D3DVECTOR
          
          Vector_Dir.X = -Sin(yaw * RAD) * Cos(pitch)
          Vector_Dir.Y = Sin(pitch * RAD)
          Vector_Dir.Z = Cos(pitch * RAD) * Cos(yaw * RAD)


End Function




Function Vector_Lerp(Vstart As D3DVECTOR, Vend As D3DVECTOR, val) As D3DVECTOR
Dim T
T = 1 - val

   Vector_Lerp.X = (T * Vstart.X) + (val * Vend.X)
   Vector_Lerp.Y = (T * Vstart.Y) + (val * Vend.Y)
   Vector_Lerp.Z = (T * Vstart.Z) + (val * Vend.Z)

End Function

Public Function RVertex(X, Y, Z, nx, ny, nz, tu, tv) As D3DVERTEX
 With RVertex
  .X = X
  .Y = Y
  .Z = Z
  .nx = nx
  .ny = ny
  .nz = nz
  .tu = tu
  .tv = tv
 End With
End Function

Public Function LVertex(X, Y, Z, COLOR, tu, tv) As D3DLVERTEX
 With LVertex
  .X = X
  .Y = Y
  .Z = Z
  .COLOR = COLOR
  .specular = COLOR
  .tu = tu
  .tv = tv
 End With
End Function

Function TLVertex(X, Y, Z, COLOR, tu, tv) As D3DTLVERTEX
 TLVertex.Sx = X
 TLVertex.sy = Y
 TLVertex.Sz = Z
 TLVertex.COLOR = COLOR
 TLVertex.specular = COLOR
 TLVertex.rhw = 0.5
 TLVertex.tu = tu
 TLVertex.tv = tv
End Function









Function Write_VERTEX(STfile As String, lpVert() As D3DVERTEX)

Dim I, J, Z, fFIL

I = LBound(lpVert)
J = UBound(lpVert)


fFIL = FreeFile
Dim ST As String

Open STfile For Output As #fFIL



For Z = I To J
    ST = Str(lpVert(Z).X) + "," + Str(lpVert(Z).Y) + "," + Str(lpVert(Z).Z) + "," + Str(lpVert(Z).tu) + "," + Str(lpVert(Z).tv) + ", _"
    
   
    Print #fFIL, ST
    


Next Z


Close #fFIL






End Function





Function Write_INdices(STfile As String, lpVert() As Integer)

Dim I, J, Z, fFIL, NUMin, Step, K, L

I = LBound(lpVert)
J = UBound(lpVert)


NUMin = J

Step = Int(NUMin / 6)

fFIL = FreeFile
Dim ST As String

Open STfile For Output As #fFIL



For L = 1 To Step
    ST = Str(lpVert(Z)) + "," + Str(lpVert(Z + 1)) + "," + Str(lpVert(Z + 2)) + "," + Str(lpVert(Z + 3)) + "," + Str(lpVert(Z + 4)) + "," + Str(lpVert(Z + 5)) + ", _"
    
   
    Print #fFIL, ST
    

    Z = Z + 6
Next L

Dim RESTE
RESTE = NUMin - (6 * Step)
If RESTE < 1 Then GoTo finiT
For K = 1 To RESTE
   ST = Str(lpVert(Z + K))
    
   
    Print #fFIL, ST

Next K



finiT:

Close #fFIL






End Function

 Public Function Floor(VALUE As Single) As Single
    If Int(VALUE) < VALUE Then
        Floor = Int(VALUE)
    Else
        Floor = VALUE
    End If
End Function
Public Function Ceil(VALUE As Single) As Single
    If Int(VALUE) < VALUE Then
        Ceil = Int(VALUE) + 1
    Else
        Ceil = VALUE
    End If
End Function



Sub GetSquaredSize(ByRef CWidth As Long, ByRef CHeight As Long)
   If CWidth > 2 And CWidth <= 4 Then CWidth = 4
   If CWidth > 4 And CWidth <= 8 Then CWidth = 8
   If CWidth > 8 And CWidth <= 16 Then CWidth = 16
   If CWidth > 16 And CWidth <= 32 Then CWidth = 32
   If CWidth > 32 And CWidth <= 64 Then CWidth = 64
   If CWidth > 64 And CWidth <= 128 Then CWidth = 128
   If CWidth > 128 Then CWidth = 256
   If CHeight > 2 And CHeight <= 4 Then CHeight = 4
   If CHeight > 4 And CHeight <= 8 Then CHeight = 8
   If CHeight > 8 And CHeight <= 16 Then CHeight = 16
   If CHeight > 16 And CHeight <= 32 Then CHeight = 32
   If CHeight > 32 And CHeight <= 64 Then CHeight = 64
   If CHeight > 64 And CHeight <= 128 Then CHeight = 128
   If CHeight > 128 Then CHeight = 256
End Sub

Function DXColor(R, G, B, A) As D3DCOLORVALUE
 DXColor.A = A
 DXColor.B = B
 DXColor.G = G
 DXColor.R = R
End Function



Function CreateMatrix(RotVec As D3DVECTOR, ScalVec As D3DVECTOR, TransVec As D3DVECTOR) As D3DMATRIX ':( Missing Scope

  Dim CosRx As Single, CosRy As Single, CosRz As Single
  Dim SinRx As Single, SinRy As Single, SinRz As Single

  Dim Rx As Single, Ry As Single, Rz As Single, Sx As Single, _
          sy As Single, Sz As Single, Tx As Single, Ty As Single, tz As Single

    Rx = RotVec.X
    Ry = RotVec.Y
    Rz = RotVec.Z

    Sx = ScalVec.X
    sy = ScalVec.Y
    Sz = ScalVec.Z

    Tx = TransVec.X
    Ty = TransVec.Y
    tz = TransVec.Z

  Dim Zpi ':( As Variant ?':( Move line to top of current Function
    Zpi = 3.14564875441112
  Dim Zrad ':( As Variant ?':( Move line to top of current Function
    Zrad = Zpi / 180
  Dim DXc As New DirectX7 ':( Move line to top of current Function

    DXc.IdentityMatrix CreateMatrix

    CosRx = Cos(Rx * Zrad) 'Used 6x
    CosRy = Cos(Ry * Zrad) 'Used 4x
    CosRz = Cos(Rz * Zrad) 'Used 4x
    SinRx = Sin(Rx * Zrad) 'Used 5x
    SinRy = Sin(Ry * Zrad) 'Used 5x
    SinRz = Sin(Rz * Zrad) 'Used 5x
    

    With CreateMatrix
        .rc11 = (Sx * CosRy * CosRz)
        .rc12 = (Sx * CosRy * SinRz)
        .rc13 = -(Sx * SinRy)
        
        .rc21 = -(sy * CosRx * SinRz) + (sy * SinRx * SinRy * CosRz)
        .rc22 = (sy * CosRx * CosRz) + (sy * SinRx * SinRy * SinRz)
        .rc23 = (sy * SinRx * CosRy)
        
        .rc31 = (Sz * SinRx * SinRz) + (Sz * CosRx * SinRy * CosRz)
        .rc32 = -(Sz * SinRx * CosRx) + (Sz * CosRx * SinRy * SinRz)
        .rc33 = (Sz * CosRx * CosRy)
        
        .rc41 = Tx
        .rc42 = Ty
        .rc43 = tz
        .rc44 = 1#
    End With 'CREATEMATRIX

    Set DXc = Nothing

End Function '


Sub OBJECT_Scale_Rotate_MOV(Xscal, Yscal, Zscal, Xrot, Yrot, Zrot, Xmov, Ymov, Zmov)
Dim Matz As D3DMATRIX
Dim ROTz As D3DMATRIX
Dim MOVz As D3DMATRIX
Dim TEMPz As D3DMATRIX
Dim DX As New DirectX7

DX.IdentityMatrix Matz
DX.IdentityMatrix MOVz
DX.IdentityMatrix ROTz

Matz = MScale(Matz, Xscal, Yscal, Zscal)
ROTz = MRotate(ROTz, Xrot, Yrot, Zrot)
MOVz = MTranslate(MOVz, Xmov, Ymov, Zmov)

DX.MatrixMultiply TEMPz, Matz, ROTz
DX.MatrixMultiply Matz, TEMPz, MOVz


Set DX = Nothing

'D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz





End Sub



Function Matrix_Get(Xscal, Yscal, Zscal, Xrot, Yrot, Zrot, Xmov, Ymov, Zmov) As D3DMATRIX
Dim Matz As D3DMATRIX
Dim ROTz As D3DMATRIX
Dim MOVz As D3DMATRIX
Dim TEMPz As D3DMATRIX
Dim DX As New DirectX7

DX.IdentityMatrix Matz
DX.IdentityMatrix MOVz
DX.IdentityMatrix ROTz

Matz = MScale(Matz, Xscal, Yscal, Zscal)
ROTz = MRotate(ROTz, Xrot, Yrot, Zrot)
MOVz = MTranslate(MOVz, Xmov, Ymov, Zmov)

DX.MatrixMultiply TEMPz, Matz, ROTz
DX.MatrixMultiply Matz, TEMPz, MOVz


Set DX = Nothing

Matrix_Get = Matz

End Function




Public Function VectorMatrixMultiply(vDest As D3DVECTOR, _
                                     vSrc As D3DVECTOR, _
                                     Mat As D3DMATRIX)

  Dim X, Y, Z, W ':( As Variant ?

    X = vSrc.X * Mat.rc11 + vSrc.Y * Mat.rc21 + vSrc.Z * Mat.rc31 + Mat.rc41
    Y = vSrc.X * Mat.rc12 + vSrc.Y * Mat.rc22 + vSrc.Z * Mat.rc32 + Mat.rc42
    Z = vSrc.X * Mat.rc13 + vSrc.Y * Mat.rc23 + vSrc.Z * Mat.rc33 + Mat.rc43
    W = vSrc.X * Mat.rc14 + vSrc.Y * Mat.rc24 + vSrc.Z * Mat.rc34 + Mat.rc44
    
    If Abs(W) < 0.0000000001 Then
        VectorMatrixMultiply = 0
        Exit Function '>---> Bottom
    End If

    vDest.X = X / W
    vDest.Y = Y / W
    vDest.Z = Z / W

    VectorMatrixMultiply = 1

End Function


Function VerTEX_MatMULTILPY(vert() As D3DVERTEX, MATA As D3DMATRIX, retVert() As D3DVERTEX)

Dim I, J, Z
I = LBound(vert)
J = UBound(vert)
'Dim retVert() As D3DVERTEX
ReDim Preserve retVert(I To J) As D3DVERTEX
retVert = vert
Dim VC As D3DVECTOR
For Z = I To J
    VC = VICTOR(retVert(Z).X, retVert(Z).Y, retVert(Z).Z)
    VectorMatrixMultiply VC, VC, MATA
    
    retVert(Z).X = VC.X '(retVert(Z).x * MATA.rc11) + (retVert(Z).Y * MATA.rc21) + (retVert(Z).Z * MATA.rc31) + MATA.rc41
    retVert(Z).Y = VC.Y '(retVert(Z).x * MATA.rc12) + (retVert(Z).Y * MATA.rc22) + (retVert(Z).Z * MATA.rc32) + MATA.rc42
    retVert(Z).Z = VC.Z '(retVert(Z).x * MATA.rc13) + (retVert(Z).Y * MATA.rc23) + (retVert(Z).Z * MATA.rc33) + MATA.rc43
Next Z


End Function



Public Function VDist(VA As D3DVECTOR, VB As D3DVECTOR) As Single

    VDist = Sqr((VB.X - VA.X) ^ 2 + (VB.Y - VA.Y) ^ 2 + (VB.Z - VA.Z) ^ 2)

End Function

Public Function Vsub(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR

  Dim Dest As D3DVECTOR

    Dest.X = A.X - B.X
    Dest.Y = A.Y - B.Y
    Dest.Z = A.Z - B.Z
    Vsub = Dest

End Function

Public Function Vmiddle(VA As D3DVECTOR, VB As D3DVECTOR) As D3DVECTOR

    Vmiddle.X = (VA.X + VB.X) / 2
    Vmiddle.Y = (VA.Y + VB.Y) / 2
    Vmiddle.Z = (VA.Z + VB.Z) / 2

End Function


Function min(V1, V2)
  If V1 < V2 Then min = V1
  If V2 < V1 Then min = V2
  If V2 = V1 Then min = V1
End Function

Function max(V1, V2)
  If V1 > V2 Then max = V1
  If V2 > V1 Then max = V2
  If V2 = V1 Then max = V1
End Function


Function MAX_3(V1, V2, V3)
      If V1 > V2 And V1 > V3 Then MAX_3 = V1
      If V2 > V1 And V2 > V3 Then MAX_3 = V2
      If V3 > V2 And V3 > V1 Then MAX_3 = V3
      
     If MAX_3 = 0 Then
      If V1 > V2 And V1 = V3 Then MAX_3 = V1
      If V2 > V3 And V2 = V1 Then MAX_3 = V2
      If V3 > V2 And V3 = V1 Then MAX_3 = V3
    End If
    
    If MAX_3 = 0 Then
     If V1 = V2 And V1 = V3 Then MAX_3 = V1
     
    End If
    
      
End Function


Public Function Vmult(SrcVec As D3DVECTOR, ByVal val) As D3DVECTOR
   Vmult.X = SrcVec.X * val
   Vmult.Y = SrcVec.Y * val
   Vmult.Z = SrcVec.Z * val
End Function


Public Function VAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR

  Dim Dest As D3DVECTOR

    Dest.X = A.X + B.X
    Dest.Y = A.Y + B.Y
    Dest.Z = A.Z + B.Z
    VAdd = Dest

End Function

Public Function VScale(src As D3DVECTOR, S As Single) As D3DVECTOR

  Dim Dest As D3DVECTOR

    Dest.X = src.X * S
    Dest.Y = src.Y * S
    Dest.Z = src.Z * S
    VScale = Dest

End Function

Function RetIdentityMatrix() As D3DMATRIX ':( Missing Scope

  Dim RET As D3DMATRIX

    IdentityMatrix RET

End Function

'=================================
' IdentityMatrix
'=================================
Sub IdentityMatrix(Dest As D3DMATRIX) ':( Missing Scope
  
    Dest.rc11 = 1
    Dest.rc12 = 0
    Dest.rc13 = 0
    Dest.rc14 = 0
    Dest.rc21 = 0
    Dest.rc22 = 1
    Dest.rc23 = 0
    Dest.rc24 = 0
    Dest.rc31 = 0
    Dest.rc32 = 0
    Dest.rc33 = 1
    Dest.rc34 = 0
    Dest.rc41 = 0
    Dest.rc42 = 0
    Dest.rc43 = 0
    Dest.rc44 = 1
  
End Sub

Public Sub MIdentity(dMatrix As D3DMATRIX)

    dMatrix.rc11 = 1
    dMatrix.rc12 = 0
    dMatrix.rc13 = 0
    dMatrix.rc14 = 0
    dMatrix.rc21 = 0
    dMatrix.rc22 = 1
    dMatrix.rc23 = 0
    dMatrix.rc24 = 0
    dMatrix.rc31 = 0
    dMatrix.rc32 = 0
    dMatrix.rc33 = 1
    dMatrix.rc34 = 0
    dMatrix.rc41 = 0
    dMatrix.rc42 = 0
    dMatrix.rc43 = 0
    dMatrix.rc44 = 1

End Sub

 Function MRotate(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

    ' Setup local variables ...
       MRotate = dSource
       ' DirectX.IdentityMatrix MRotate
        Dim L_nCos As Single        ' Holds cosine value of angle
        Dim L_nSin As Single        ' Holds sine value of angle
        
    ' Do rotation around X-Axis ...
        If nValueX <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
                
            ' Get angle values
            L_nCos = Cos(nValueX * PIFactor)
            L_nSin = Sin(nValueX * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc22 = L_nCos
                .rc33 = L_nCos
                .rc23 = -L_nSin
                .rc32 = L_nSin
            End With
            
            ' Apply transformations
            MRotate = MMultiply(P_dCalculatorMatrix, MRotate)
            
        End If
    
    ' Do rotation around Y-Axis ...
        If nValueY <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
            
            ' Get angle values
            L_nCos = Cos(nValueY * PIFactor)
            L_nSin = Sin(nValueY * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc11 = L_nCos
                .rc33 = L_nCos
                .rc13 = L_nSin
                .rc31 = -L_nSin
            End With
            
            ' Apply transformations
            MRotate = MMultiply(P_dCalculatorMatrix, MRotate)
            
        End If
        
    ' Do rotation around Z-Axis ...
        If nValueZ <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
            
            ' Get angle values
            L_nCos = Cos(nValueZ * PIFactor)
            L_nSin = Sin(nValueZ * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc11 = L_nCos
                .rc22 = L_nCos
                .rc12 = -L_nSin
                .rc21 = L_nSin
            End With
            
            ' Apply transformations
            MRotate = MMultiply(P_dCalculatorMatrix, MRotate)
            
        End If
        
    ' Return result ...
     
    
End Function





' MTRANSLATE: Translates a matrix along the axis
Public Function MTranslate(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

  ' Reset to identity matrix

    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc41 = nValueX
        .rc42 = nValueY
        .rc43 = nValueZ
    End With 'P_DCALCULATORMATRIX

    ' Apply transformations

    ' Return result
    MTranslate = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function


Sub Matrix_Invert(DestMat As D3DMATRIX, Mat As D3DMATRIX)

Dim FdetInv

If Abs((Mat.rc44 - 1#) > 0.001) Then Exit Sub
    If (Abs(Mat.rc14) > 0.001 And Abs(Mat.rc24) > 0.001 And Abs(Mat.rc34) > 0.001) Then Exit Sub

    
     FdetInv = 1# / (Mat.rc11 * (Mat.rc22 * Mat.rc33 - Mat.rc23 * Mat.rc32) - _
        Mat.rc12 * (Mat.rc21 * Mat.rc33 - Mat.rc23 * Mat.rc31) + _
        Mat.rc13 * (Mat.rc21 * Mat.rc32 - Mat.rc22 * Mat.rc31))

    DestMat.rc11 = FdetInv * (Mat.rc22 * Mat.rc33 - Mat.rc23 * Mat.rc32)
    DestMat.rc12 = -FdetInv * (Mat.rc12 * Mat.rc33 - Mat.rc13 * Mat.rc32)
    DestMat.rc13 = FdetInv * (Mat.rc12 * Mat.rc23 - Mat.rc13 * Mat.rc22)
    DestMat.rc14 = 0#

    DestMat.rc21 = -FdetInv * (Mat.rc21 * Mat.rc33 - Mat.rc23 * Mat.rc31)
    DestMat.rc22 = FdetInv * (Mat.rc11 * Mat.rc33 - Mat.rc13 * Mat.rc31)
    DestMat.rc23 = -FdetInv * (Mat.rc11 * Mat.rc23 - Mat.rc13 * Mat.rc21)
    DestMat.rc24 = 0#

    DestMat.rc31 = FdetInv * (Mat.rc21 * Mat.rc32 - Mat.rc22 * Mat.rc31)
    DestMat.rc32 = -FdetInv * (Mat.rc11 * Mat.rc32 - Mat.rc12 * Mat.rc31)
    DestMat.rc33 = FdetInv * (Mat.rc11 * Mat.rc22 - Mat.rc12 * Mat.rc21)
    DestMat.rc34 = 0#

    DestMat.rc41 = -(Mat.rc41 * DestMat.rc11 + Mat.rc42 * DestMat.rc21 + Mat.rc43 * DestMat.rc31)
    DestMat.rc42 = -(Mat.rc41 * DestMat.rc12 + Mat.rc42 * DestMat.rc22 + Mat.rc43 * DestMat.rc32)
    DestMat.rc43 = -(Mat.rc41 * DestMat.rc13 + Mat.rc42 * DestMat.rc23 + Mat.rc43 * DestMat.rc33)
    DestMat.rc44 = 1#

End Sub

Public Function MTrans_EX(dSource As D3DMATRIX, Vec As D3DVECTOR) As D3DMATRIX

  ' Reset to identity matrix

    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc41 = Vec.X
        .rc42 = Vec.Y
        .rc43 = Vec.Z
    End With 'P_DCALCULATORMATRIX

    ' Apply transformations

    ' Return result
    MTrans_EX = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function

Function MATRIX_Scale_Rotate_MOV(Vscal As D3DVECTOR, Vrot As D3DVECTOR, Vmov As D3DVECTOR) As D3DMATRIX ':( Missing Scope

  Dim Matz As D3DMATRIX
  Dim ROTz As D3DMATRIX
  Dim MOVz As D3DMATRIX
  Dim TEMPz As D3DMATRIX
  Dim DX7 As New DirectX7
    DX7.IdentityMatrix Matz
    DX7.IdentityMatrix MOVz
    DX7.IdentityMatrix ROTz

    Matz = MScale(Matz, Vscal.X, Vscal.Y, Vscal.Z)
    ROTz = MRotate(ROTz, Vrot.X, Vrot.Y, Vrot.Z)
    MOVz = MTranslate(MOVz, Vmov.X, Vmov.Y, Vmov.Z)

    DX7.MatrixMultiply TEMPz, Matz, ROTz
    DX7.MatrixMultiply Matz, TEMPz, MOVz

    MATRIX_Scale_Rotate_MOV = Matz
 Set DX7 = Nothing
End Function

Public Function MMultiply(dM1 As D3DMATRIX, dM2 As D3DMATRIX) As D3DMATRIX

  Dim DX7 As New DirectX7

    ' Calculate multiply ...
    DX7.MatrixMultiply MMultiply, dM2, dM1
    Set DX7 = Nothing

End Function

' MSCALE: Scales a matrix along the axis
Public Function MScale(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

  ' Reset to identity matrix

    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc11 = nValueX
        .rc22 = nValueY
        .rc33 = nValueZ
    End With 'P_DCALCULATORMATRIX
    
    ' Apply transformations
    
    ' Return result
    ' dSource =
    
    MScale = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function

':) Ulli's VB Code Formatter V2.3.18 (17/10/2001 20:53:03) 0 + 291 = 291 Lines
 Sub Class_Initialize()
 PIFactor = 3.14598745148 / 180
 
End Sub

Function RetColor(R255, G255, B255, AlPHA255) As D3DCOLORVALUE
    With RetColor
       .R = R255 / 255
       .G = G255 / 255
       .B = B255 / 255
       .A = AlPHA255 / 255
    End With
End Function

Public Function Rotate(v As D3DVECTOR, xA, yA, zA) As D3DVECTOR
   Dim XPP1 As Double, YPP1 As Double, ZPP3 As Double, XPP2 As Double, ZPP2 As Double, YPP3 As Double
   Dim X                          As Double
   Dim Y                          As Double
   Dim Z                          As Double
   Dim cXA                        As Double
   Dim cYA                        As Double
   Dim cZA                        As Double
   Dim sXA                        As Double
   Dim sYA                        As Double
   Dim sZA                        As Double
   cXA = Cos(xA * RAD)
   cYA = Cos(yA * RAD)
   cZA = Cos(zA * RAD)
   sXA = Sin(xA * RAD)
   sYA = Sin(yA * RAD)
   sZA = Sin(zA * RAD)
   X = v.X
   Y = v.Y
   Z = v.Z
   XPP1 = X * cXA + Y * sXA
   YPP1 = Y * cXA - X * sXA
   XPP2 = XPP1 * cYA + Z * sYA
   ZPP2 = Z * cYA - XPP1 * sYA
   YPP3 = YPP1 * cZA - ZPP2 * sZA
   ZPP3 = ZPP2 * cZA + YPP1 * sZA
   Rotate.X = XPP2
   Rotate.Y = YPP3
   Rotate.Z = ZPP3
End Function

Sub ViewMatrix(view As D3DMATRIX, from As D3DVECTOR, At As D3DVECTOR, world_up As D3DVECTOR, roll As Single)
  
  Dim Up As D3DVECTOR
  Dim Right As D3DVECTOR
  Dim view_Dir As D3DVECTOR
  
  Call IdentityMatrix(view)
  Call VectorSubtract(view_Dir, At, from)
  Call VectorNormalize(view_Dir)
  
  'think lefthanded coords
  Call VectorCrossProduct(Right, world_up, view_Dir)
  Call VectorCrossProduct(Up, view_Dir, Right)
  
  Call VectorNormalize(Right)
  Call VectorNormalize(Up)
  
  view.rc11 = Right.X
  view.rc21 = Right.Y
  view.rc31 = Right.Z
  view.rc12 = Up.X   'AK? should this be negative?
  view.rc22 = Up.Y
  view.rc32 = Up.Z
  view.rc13 = view_Dir.X
  view.rc23 = view_Dir.Y
  view.rc33 = view_Dir.Z
  
  view.rc41 = -VectorDotProduct(Right, from)
  view.rc42 = -VectorDotProduct(Up, from)
  view.rc43 = -VectorDotProduct(view_Dir, from)

  ' Set roll
  If (roll <> 0#) Then
      Dim rotZMat As D3DMATRIX
      Call RotateZMatrix(rotZMat, -roll)
      Call MatrixMult(view, rotZMat, view)
  End If
  
  
End Sub

Function VERTEXtoVEC(vert As D3DVERTEX) As D3DVECTOR
VERTEXtoVEC.X = vert.X
VERTEXtoVEC.Y = vert.Y
VERTEXtoVEC.Z = vert.Z



End Function
Function LVERTEXtoVEC(vert As D3DLVERTEX) As D3DVECTOR
LVERTEXtoVEC.X = vert.X
LVERTEXtoVEC.Y = vert.Y
LVERTEXtoVEC.Z = vert.Z



End Function


Function GET_fileName(LongNAME As String) As String

  Dim ST As String
  Dim zz, I ':( As Variant ?
  Dim EXT ':( As Variant ?
  Dim ST1 As String

    For I = Len(LongNAME) To 1 Step -1
 
        If Mid$(LongNAME, I, 1) = "." Then Exit For ':( Expand Structure or consider reversing Condition
    Next I

    EXT = Len(LongNAME) - I

    zz = Len(LongNAME)

    For I = zz To 1 Step -1
        If Mid$(LongNAME, I, 1) = "\" Or Mid$(LongNAME, I, 1) = "/" Then Exit For ':( Expand Structure or consider reversing Condition
    Next ':( Repeat For-Variable: I

    ST1 = Right$(LongNAME, zz - I)

    On Error GoTo ooF
    If InStr(LongNAME, ".") > 0 Then GET_fileName = Left$(ST1, Len(ST1) - EXT - 1) ':( Expand Structure
    If InStr(LongNAME, ".") < 1 Then GET_fileName = Left$(ST1, Len(ST1)) ':( Expand Structure

Exit Function

ooF:
    GET_fileName = ST1

End Function




Function GetLongFolDerName(STlongFilename As String)
Dim ST As String
Dim Temp As String
Dim I As Integer
    ST = GET_fileName(STlongFilename)
    I = InStr(STlongFilename, ST)
    Temp = Left(STlongFilename, I - 2)
    GetLongFolDerName = Temp
End Function


Function GET_pathName(LongNAME As String) As String

  Dim ST As String
  Dim zz, I ':( As Variant ?
  Dim ST1 As String

    zz = Len(LongNAME)

    For I = zz To 1 Step -1
        If Mid$(LongNAME, I, 1) = "\" Or Mid$(LongNAME, I, 1) = "/" Then Exit For ':( Expand Structure or consider reversing Condition
    Next ':( Repeat For-Variable: I

    ST1 = Left$(LongNAME, I - 1)
    GET_pathName = ST1

End Function

Function GET_LastpathName(LongNAME As String) As String
Dim ST As String
Dim ST1 As String
Dim zz, I, J, POS1, POS2
zz = Len(LongNAME)

For I = zz To 1 Step -1
J = J + 1
   If Mid(LongNAME, I, 1) = "\" Or Mid(LongNAME, I, 1) = "/" Then
      If POS1 = 0 Then
         POS1 = I
         GoTo nexta
       End If
      If POS1 > 0 And POS2 = 0 Then POS2 = I
   End If
nexta:

If I = 1 Or POS2 > 0 Then
  If POS2 = 0 Then POS2 = 1
End If

Next


ST1 = Mid(LongNAME, POS2 + 1, POS1 - POS2 - 1)
GET_LastpathName = ST1


End Function








Sub Get_BoundingBOX(lpVert() As D3DVERTEX, ByRef RetBox As D3DRMBOX)
Dim I, J, zz
Dim Vec As D3DVECTOR

' bounding box
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
   
 I = LBound(lpVert)
 J = UBound(lpVert)
 
   
For zz = I To J
   With lpVert(zz)
       If .X > max.X Then max.X = .X
       If .Y > max.Y Then max.Y = .Y
       If .Z > max.Z Then max.Z = .Z
       If .X < min.X Then min.X = .X
       If .Y < min.Y Then min.Y = .Y
       If .Z < min.Z Then min.Z = .Z
       
      End With
Next zz
RetBox.max = max
RetBox.min = min
End Sub




Sub Get_BoundingSphere(lpVert() As D3DVERTEX, ByRef RetSphereCenter As D3DVECTOR, RetRadius)
Dim I, J, zz
Dim Vec As D3DVECTOR

' bounding box
   Dim Vmin As D3DVECTOR
   Dim Vmax As D3DVECTOR
   Vmin = Vector(99999999, 999999999, 999999999)
   Vmax = Vector(-999999999, -999999999, -999999999)
   
 I = LBound(lpVert)
 J = UBound(lpVert)
 
   
For zz = I To J
   With lpVert(zz)
       If .X > Vmax.X Then Vmax.X = .X
       If .Y > Vmax.Y Then Vmax.Y = .Y
       If .Z > Vmax.Z Then Vmax.Z = .Z
       If .X < Vmin.X Then Vmin.X = .X
       If .Y < Vmin.Y Then Vmin.Y = .Y
       If .Z < Vmin.Z Then Vmin.Z = .Z
       
      End With
Next zz

   RetRadius = MAX_3(Vmax.X - Vmin.X, Vmax.Y - Vmin.Y, Vmax.Z - Vmin.Z) / 2
  RetSphereCenter = Vmiddle(Vmax, Vmin)
End Sub

'colision Detection
Function BOX_GetBoxCollision(Box1 As D3DRMBOX, Box2 As D3DRMBOX) As Boolean
Dim vec1 As D3DVECTOR
Dim vec2 As D3DVECTOR
Dim vec3 As D3DVECTOR
Dim vec4 As D3DVECTOR
Dim vec5 As D3DVECTOR
Dim Vec6 As D3DVECTOR

With Box2
vec1 = VICTOR(.min.X, .min.Y, .max.Z)
vec2 = VICTOR(.max.X, .min.Y, .max.Z)
vec3 = VICTOR(.min.X, .max.Y, .min.Z)
vec4 = VICTOR(.min.X, .max.Y, .max.Z)

vec5 = VICTOR(.max.X, .min.Y, .min.Z)
Vec6 = VICTOR(.max.X, .max.Y, .min.Z)

End With

If BOX_GetPointBOXCollision(Box1, Box2.max) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, Box2.min) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, vec1) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, vec2) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, vec3) Then
  BOX_GetBoxCollision = True
  Exit Function

ElseIf BOX_GetPointBOXCollision(Box1, vec4) Then
  BOX_GetBoxCollision = True
  Exit Function

ElseIf BOX_GetPointBOXCollision(Box1, vec5) Then
  BOX_GetBoxCollision = True
  Exit Function

ElseIf BOX_GetPointBOXCollision(Box1, Vec6) Then
  BOX_GetBoxCollision = True
  Exit Function
  
  
End If


End Function


Sub CreateBox(Vmin As D3DVECTOR, Vmax As D3DVECTOR, RetBox As D3DRMBOX)
  RetBox.min = Vmin
  RetBox.max = Vmax


End Sub


Function BOX_GetPointBOXCollision(OBJbox As D3DRMBOX, Tpoint As D3DVECTOR) As Boolean

 '===============Teste de colision

If Tpoint.X > OBJbox.min.X And Tpoint.X < OBJbox.max.X And _
 Tpoint.Y > OBJbox.min.Y And Tpoint.Y < OBJbox.max.Y And _
 Tpoint.Z > OBJbox.min.Z And Tpoint.Z < OBJbox.max.Z Then _
 BOX_GetPointBOXCollision = True



End Function

Sub VNormalize(Dest As D3DVECTOR)
  On Local Error Resume Next
  Dim L As Double
  L = Dest.X * Dest.X + Dest.Y * Dest.Y + Dest.Z * Dest.Z
  L = Sqr(L)
  If L = 0 Then
    Dest.X = 0
    Dest.Y = 0
    Dest.Z = 0
    Exit Sub
  End If
  Dest.X = Dest.X / L
  Dest.Y = Dest.Y / L
  Dest.Z = Dest.Z / L
End Sub


Sub VectorNormalize(Dest As D3DVECTOR)
  On Local Error Resume Next
  Dim L As Double
  L = Dest.X * Dest.X + Dest.Y * Dest.Y + Dest.Z * Dest.Z
  L = Sqr(L)
  If L = 0 Then
    Dest.X = 0
    Dest.Y = 0
    Dest.Z = 0
    Exit Sub
  End If
  Dest.X = Dest.X / L
  Dest.Y = Dest.Y / L
  Dest.Z = Dest.Z / L
End Sub

Function Vector_Rotate(Vec As D3DVECTOR, angleX, angleY, angleZ) As D3DVECTOR
Dim TempVec As D3DVECTOR
TempVec = Vec
    Dim qx  As Single, qy    As Single, qz    As Single, qw    As Single, tmpx    As Single, tmpy    As Single, tmpz As Single
    Call Euler2quat(angleX, angleY, angleZ, qw, qx, qy, qz)
    tmpx = TempVec.X * (1 - 2 * qy * qy - 2 * qz * qz) + TempVec.Y * (2 * qx * qy - 2 * qw * qz) + TempVec.Z * (2 * qx * qz + 2 * qw * qy)
    tmpy = TempVec.X * (2 * qx * qy + 2 * qw * qz) + TempVec.Y * (1 - 2 * qx * qx - 2 * qz * qz) + TempVec.Z * (2 * qy * qz - 2 * qw * qx)
    tmpz = TempVec.X * (2 * qx * qz - 2 * qw * qy) + TempVec.Y * (2 * qy * qz + 2 * qw * qx) + TempVec.Z * (1 - 2 * qx * qx - 2 * qy * qy)
    Vector_Rotate.X = tmpx
    Vector_Rotate.Y = tmpy
    Vector_Rotate.Z = tmpz

End Function

Function Vector_RotateEX(Vec As D3DVECTOR, rotQuat As D3DRMQUATERNION) As D3DVECTOR
    Dim tmpx, tmpy, tmpz
    tmpx = Vec.X * (1 - 2 * rotQuat.v.Y * rotQuat.v.Y - 2 * rotQuat.v.Z * rotQuat.v.Z) + Vec.Y * (2 * rotQuat.v.X * rotQuat.v.Y - 2 * rotQuat.S * rotQuat.v.Z) + Vec.Z * (2 * rotQuat.v.X * rotQuat.v.Z + 2 * rotQuat.S * rotQuat.v.Y)
    tmpy = Vec.X * (2 * rotQuat.v.X * rotQuat.v.Y + 2 * rotQuat.S * rotQuat.v.Z) + Vec.Y * (1 - 2 * rotQuat.v.X * rotQuat.v.X - 2 * rotQuat.v.Z * rotQuat.v.Z) + Vec.Z * (2 * rotQuat.v.Y * rotQuat.v.Z - 2 * rotQuat.S * rotQuat.v.X)
    tmpz = Vec.X * (2 * rotQuat.v.X * rotQuat.v.Z - 2 * rotQuat.S * rotQuat.v.Y) + Vec.Y * (2 * rotQuat.v.Y * rotQuat.v.Z + 2 * rotQuat.S * rotQuat.v.X) + Vec.Z * (1 - 2 * rotQuat.v.X * rotQuat.v.X - 2 * rotQuat.v.Y * rotQuat.v.Y)
    Vector_RotateEX.X = tmpx
    Vector_RotateEX.Y = tmpy
    Vector_RotateEX.Z = tmpz
End Function

Function Acos(X)
On Error Resume Next
Acos = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
End Function



Sub Quaternion_ToMatrix(Quat As D3DRMQUATERNION, RetMat As D3DMATRIX)


RetMat = RetIdentityMatrix
Dim wx, wy, wz, XX, yY, yz, xy, xz, zz, x2, Y2, z2

   x2 = Quat.v.X + Quat.v.X
   Y2 = Quat.v.Y + Quat.v.Y
   z2 = Quat.v.Z + Quat.v.Z

   XX = Quat.v.X * x2
   xy = Quat.v.X * Y2
   xz = Quat.v.X * z2
   yY = Quat.v.Y * Y2
   yz = Quat.v.Y * z2
   zz = Quat.v.Z * z2
   wx = Quat.S * x2
   wy = Quat.S * Y2
   wz = Quat.S * z2

   
   RetMat.rc11 = 1# - (yY + zz)
   RetMat.rc12 = xy - wz
   RetMat.rc13 = xz + wy
   RetMat.rc14 = 0#
   RetMat.rc21 = xy + wz
   RetMat.rc22 = 1# - (XX + zz)
   RetMat.rc23 = yz - wx
   RetMat.rc24 = 0#
   RetMat.rc31 = xz - wy
   RetMat.rc32 = yz + wx
   RetMat.rc33 = 1# - (XX + yY)
   RetMat.rc34 = 0#
   RetMat.rc41 = 0
   RetMat.rc42 = 0
   RetMat.rc43 = 0
   RetMat.rc44 = 1

End Sub


Sub Quaternion_FromEulerAngle(ByVal Ax As Single, ByVal Ay As Single, ByVal Az As Single, ByRef W As Single, ByRef X As Single, ByRef Y As Single, ByRef Z)


  Dim ex  As Double, ey    As Double, ez As Double
  Dim cr  As Double, cp    As Double, cy    As Double, sr    As Double, sp    As Double, sy    As Double, cpcy    As Double, spsy As Double
  Dim norm As Double
  
  ex = DegToRad(Ax) / 2#
  ey = DegToRad(Ay) / 2#
  ez = DegToRad(Az) / 2#

  cr = Cos(ex)
  cp = Cos(ey)
  cy = Cos(ez)

  sr = Sin(ex)
  sp = Sin(ey)
  sy = Sin(ez)

  cpcy = cp * cy
  spsy = sp * sy

  W = (cr * cpcy + sr * spsy)
  X = (sr * cpcy - cr * spsy)
  Y = (cr * sp * cy + sr * cp * sy)
  Z = (cr * cp * sy - sr * sp * cy)
     norm = Sqr((X * X) + Sqr(Y * Y) + Sqr(Z * Z) + Sqr(W * W))
    If (norm = 0#) Then Exit Sub
    W = W / norm
    X = X / norm
    Y = Y / norm
    Z = Z / norm

End Sub


Sub Quaternion_FromEulerAngleEX(ByVal Ax As Single, ByVal Ay As Single, ByVal Az As Single, RetQuat As D3DRMQUATERNION)


  Dim ex  As Double, ey    As Double, ez As Double
  Dim cr  As Double, cp    As Double, cy    As Double, sr    As Double, sp    As Double, sy    As Double, cpcy    As Double, spsy As Double
  Dim norm As Double
  
  ex = DegToRad(Ax) / 2#
  ey = DegToRad(Ay) / 2#
  ez = DegToRad(Az) / 2#

  cr = Cos(ex)
  cp = Cos(ey)
  cy = Cos(ez)

  sr = Sin(ex)
  sp = Sin(ey)
  sy = Sin(ez)

  cpcy = cp * cy
  spsy = sp * sy

  RetQuat.S = (cr * cpcy + sr * spsy)
  RetQuat.v.X = (sr * cpcy - cr * spsy)
  RetQuat.v.Y = (cr * sp * cy + sr * cp * sy)
  RetQuat.v.Z = (cr * cp * sy - sr * sp * cy)
     norm = Sqr((RetQuat.v.X * RetQuat.v.X) + Sqr(RetQuat.v.Y * RetQuat.v.Y) + Sqr(RetQuat.v.Z * RetQuat.v.Z) + Sqr(RetQuat.S * RetQuat.S))
    If (norm = 0#) Then Exit Sub
    RetQuat.S = RetQuat.S / norm
    RetQuat.v.X = RetQuat.v.X / norm
    RetQuat.v.Y = RetQuat.v.Y / norm
    RetQuat.v.Z = RetQuat.v.Z / norm

End Sub



Function Quaternion_GetAxisAngle(Quat As D3DRMQUATERNION, ByRef X, ByRef Y, ByRef Z, ByRef angle)
   Dim temp_angle As Double, Scal As Double
   Dim Length As Single

    temp_angle = Acos(Quat.S)
    Scal = Sqr(Quat.v.X * Quat.v.X + Quat.v.Y * Quat.v.Y + Quat.v.Z * Quat.v.Z)

    If (Scal = 0) Then
        angle = 0#
        X = 0
        Y = 0
        Z = 0#
    Else
        angle = (temp_angle * 2#)      '// angle in radians
         X = (Quat.v.X / Scal)
         Y = (Quat.v.Y / Scal)
         Z = (Quat.v.Z / Scal)
        Length = Sqr(X * X + Y * Y + Z * Z)
      If (Length <> 0) Then
          X = X / Length
            Y = Y / Length
          Z = Z / Length
      End If
        angle = RadToDeg(angle)
    End If


End Function

Sub Quaternion_MultWith(DestQuat As D3DRMQUATERNION, q1 As D3DRMQUATERNION, q2 As D3DRMQUATERNION)

Dim Rx As Double, Ry As Double, Rz As Double, rw As Double


    rw = q1.S * q2.S - q1.v.X * q2.v.X - q1.v.Y * q2.v.Y - q1.v.Z * q2.v.Z

    Rx = q1.S * q2.v.X + q1.v.X * q2.S + q1.v.Y * q2.v.Z - q1.v.Z * q2.v.Y
    Ry = q1.S * q2.v.Y + q1.v.Y * q2.S + q1.v.Z * q2.v.X - q1.v.X * q2.v.Z
    Rz = q1.S * q2.v.Z + q1.v.Z * q2.S + q1.v.X * q2.v.Y - q1.v.Y * q2.v.X

    DestQuat.v.X = Rx
    DestQuat.v.Y = Ry
    DestQuat.v.Z = Rz
    DestQuat.S = rw

End Sub

Sub Quaternion_Normalize(DestQuat As D3DRMQUATERNION)
Dim norm As Double
 norm = Sqr(DestQuat.v.X * DestQuat.v.X + DestQuat.v.Y * DestQuat.v.Y + DestQuat.v.Z * DestQuat.v.Z + DestQuat.S * DestQuat.S)

    If (norm = 0) Then Exit Sub

    DestQuat.v.X = (DestQuat.v.X / norm)
    DestQuat.v.Y = (DestQuat.v.Y / norm)
    DestQuat.v.Z = (DestQuat.v.Z / norm)
    DestQuat.S = (DestQuat.S / norm)
End Sub

Function Vector_RotateAroundVector(VecToRot As D3DVECTOR, angleX, angleY, angleZ, VcenterRot As D3DVECTOR) As D3DVECTOR
Dim TempVec As D3DVECTOR
TempVec = VecToRot

TempVec.X = TempVec.X - VcenterRot.X
TempVec.Y = TempVec.Y - VcenterRot.Y
TempVec.Z = TempVec.Z - VcenterRot.Z

  TempVec = Vector_Rotate(TempVec, angleX, angleY, angleZ)

TempVec.X = TempVec.X + VcenterRot.X
TempVec.Y = TempVec.Y + VcenterRot.Y
TempVec.Z = TempVec.Z + VcenterRot.Z

Vector_RotateAroundVector = TempVec

End Function


Function DegToRad(XX)
    DegToRad = XX * RAD
End Function

Function RadToDeg(XX)
   RadToDeg = ((XX) * 180#) / PI
End Function

Sub Euler2quat(ByVal Ax As Single, ByVal Ay As Single, ByVal Az As Single, ByRef W As Single, ByRef X As Single, ByRef Y As Single, ByRef Z)


  Dim ex  As Double, ey    As Double, ez As Double
  Dim cr  As Double, cp    As Double, cy    As Double, sr    As Double, sp    As Double, sy    As Double, cpcy    As Double, spsy As Double
  Dim norm As Double
  
  ex = DegToRad(Ax) / 2#
  ey = DegToRad(Ay) / 2#
  ez = DegToRad(Az) / 2#

  cr = Cos(ex)
  cp = Cos(ey)
  cy = Cos(ez)

  sr = Sin(ex)
  sp = Sin(ey)
  sy = Sin(ez)

  cpcy = cp * cy
  spsy = sp * sy

  W = (cr * cpcy + sr * spsy)
  X = (sr * cpcy - cr * spsy)
  Y = (cr * sp * cy + sr * cp * sy)
  Z = (cr * cp * sy - sr * sp * cy)
     norm = Sqr((X * X) + Sqr(Y * Y) + Sqr(Z * Z) + Sqr(W * W))
    If (norm = 0#) Then Exit Sub
    W = W / norm
    X = X / norm
    Y = Y / norm
    Z = Z / norm

End Sub






Sub Euler2quatEX(ByVal Ax As Single, ByVal Ay As Single, ByVal Az As Single, RetQuat As D3DRMQUATERNION)


  Dim ex  As Double, ey    As Double, ez As Double
  Dim cr  As Double, cp    As Double, cy    As Double, sr    As Double, sp    As Double, sy    As Double, cpcy    As Double, spsy As Double
  Dim norm As Double
  
  ex = DegToRad(Ax) / 2#
  ey = DegToRad(Ay) / 2#
  ez = DegToRad(Az) / 2#

  cr = Cos(ex)
  cp = Cos(ey)
  cy = Cos(ez)

  sr = Sin(ex)
  sp = Sin(ey)
  sy = Sin(ez)

  cpcy = cp * cy
  spsy = sp * sy

  RetQuat.S = (cr * cpcy + sr * spsy)
  RetQuat.v.X = (sr * cpcy - cr * spsy)
  RetQuat.v.Y = (cr * sp * cy + sr * cp * sy)
  RetQuat.v.Z = (cr * cp * sy - sr * sp * cy)
     norm = Sqr((RetQuat.v.X * RetQuat.v.X) + Sqr(RetQuat.v.Y * RetQuat.v.Y) + Sqr(RetQuat.v.Z * RetQuat.v.Z) + Sqr(RetQuat.S * RetQuat.S))
    If (norm = 0#) Then Exit Sub
    RetQuat.S = RetQuat.S / norm
    RetQuat.v.X = RetQuat.v.X / norm
    RetQuat.v.Y = RetQuat.v.Y / norm
    RetQuat.v.Z = RetQuat.v.Z / norm

End Sub



Function VecDIV(VC As D3DVECTOR, sing) As D3DVECTOR
  VecDIV.X = VC.X / sing
  VecDIV.Y = VC.Y / sing
  VecDIV.Z = VC.Z / sing
End Function



'=================================
' VectorNegate
'=================================
 Sub VectorNegate(v As D3DVECTOR)
  v.X = -v.X
  v.Y = -v.Y
  v.Z = -v.Z
End Sub

 Function VNegate(v As D3DVECTOR) As D3DVECTOR
    Dim RET As D3DVECTOR
    RET.X = -v.X
    RET.Y = -v.Y
    RET.Z = -v.Z
    VNegate = RET
End Function

'=================================
' Vector subtract
'=================================
 Sub VectorSubtract(Dest As D3DVECTOR, A As D3DVECTOR, B As D3DVECTOR)
  Dest.X = A.X - B.X
  Dest.Y = A.Y - B.Y
  Dest.Z = A.Z - B.Z
End Sub

 

'=================================
' VectorAdd
'=================================
 Sub VectorAdd(Dest As D3DVECTOR, A As D3DVECTOR, B As D3DVECTOR)
  Dest.X = A.X + B.X
  Dest.Y = A.Y + B.Y
  Dest.Z = A.Z + B.Z
End Sub

 

'=================================
' VectorCrossProduct
'=================================
' can be used to compute normals.
'
 Sub VectorCrossProduct(Dest As D3DVECTOR, A As D3DVECTOR, B As D3DVECTOR)
   Dest.X = A.Y * B.Z - A.Z * B.Y
   Dest.Y = A.Z * B.X - A.X * B.Z
   Dest.Z = A.X * B.Y - A.Y * B.X
End Sub
  
 Function VCross(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
   Dim Dest As D3DVECTOR
   Dest.X = A.Y * B.Z - A.Z * B.Y
   Dest.Y = A.Z * B.X - A.X * B.Z
   Dest.Z = A.X * B.Y - A.Y * B.X
   VCross = Dest
End Function
  
'=================================
' VectorNormalize
'=================================
' creates a vector of length 1 in the same direction
'
 
  
 
  
'=================================
' VectorDotProduct
'=================================
 Function VectorDotProduct(A As D3DVECTOR, B As D3DVECTOR) As Single
  VectorDotProduct = A.X * B.X + A.Y * B.Y + A.Z * B.Z
End Function

 Function VDot(A As D3DVECTOR, B As D3DVECTOR) As Single
  VDot = A.X * B.X + A.Y * B.Y + A.Z * B.Z
End Function

'=================================
' VectorAddAndScale
'=================================
 Sub VectorAddAndScale(Dest As D3DVECTOR, S1 As Single, V1 As D3DVECTOR, s2 As Single, V2 As D3DVECTOR)
  Dest.X = S1 * V1.X + s2 * V2.X
  Dest.Y = S1 * V1.Y + s2 * V2.Y
  Dest.Z = S1 * V1.Z + s2 * V2.Z
End Sub

'=================================
' VectorCopy
'=================================
 Sub VectorCopy(Dest As D3DVECTOR, src As D3DVECTOR)
  Dest.X = src.X
  Dest.Y = src.Y
  Dest.Z = src.Z
End Sub

 Function VCopy(src As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = src.X
  Dest.Y = src.Y
  Dest.Z = src.Z
  VCopy = Dest
End Function

'=================================
' VectorScale
'=================================
' scale a vector by a scalar
 Sub VectorScale(Dest As D3DVECTOR, src As D3DVECTOR, S As Single)
  Dest.X = src.X * S
  Dest.Y = src.Y * S
  Dest.Z = src.Z * S
End Sub

 

'=================================
' MakeVector
'=================================
 Sub MakeVector(v As D3DVECTOR, X As Single, Y As Single, Z As Single)
    v.X = X
    v.Y = Z
    v.Z = Y
End Sub

 Function RVector(X As Single, Y As Single, Z As Single) As D3DVECTOR
    Dim v As D3DVECTOR
    v.X = X
    v.Y = Y
    v.Z = Z
    RVector = v
End Function

'=================================
' MakeVertex
'=================================
 Sub MakeVertex(RET As D3DVERTEX, Vect As D3DVECTOR, vNorm As D3DVECTOR, tu As Single, tv As Single)
    
    With RET
        .nx = vNorm.X
        .ny = vNorm.Y
        .nz = vNorm.Z
        .tu = tu
        .tv = tv
        .X = Vect.X
        .Y = Vect.Y
        .Z = Vect.Z
    End With

End Sub

 


'=================================
' MakeLVertex
'=================================
 Sub MakeLVertex(RET As D3DLVERTEX, X As Single, Y As Single, Z As Single, COLOR As Long, specular As Single, tu As Single, tv As Single)
    
    With RET
        .specular = specular
        .tu = tu
        .tv = tv
        .X = X
        .Y = Y
        .Z = Z
        .COLOR = COLOR
    End With
    
End Sub

 Function RLVertex(X As Single, Y As Single, Z As Single, COLOR As Long, specular As Single, tu As Single, tv As Single) As D3DLVERTEX
    Dim RET As D3DLVERTEX
    With RET
        .specular = specular
        .tu = tu
        .tv = tv
        .X = X
        .Y = Y
        .Z = Z
        .COLOR = COLOR
    End With
    RLVertex = RET
End Function

'=================================
' MakeTLVertex
'=================================
 Function MakeTLVertex(vert As D3DTLVERTEX, Sx As Single, sy As Single, Sz As Single, W As Single, C As Long, S As Single, U As Single, v As Single) As D3DTLVERTEX
    
    vert.Sx = Sx
    vert.sy = sy
    vert.Sz = Sz
    vert.rhw = W
    vert.COLOR = C
    vert.specular = S
    vert.tu = U
    vert.tv = v
    
End Function

 Function RTLVertex(Sx As Single, sy As Single, Sz As Single, W As Single, C As Long, S As Single, U As Single, v As Single) As D3DTLVERTEX
    Dim vert As D3DTLVERTEX
    vert.Sx = Sx
    vert.sy = sy
    vert.Sz = Sz
    vert.rhw = W
    vert.COLOR = C
    vert.specular = S
    vert.tu = U
    vert.tv = v
    RTLVertex = vert
End Function



'=================================
' MakeRect
'=================================
 Function MakeRect(RET As RECT, x1 As Single, y1 As Single, x2 As Single, Y2 As Single)
    With RET
        .Left = x1
        .Top = y1
        .Right = x2
        .Bottom = Y2
    End With
End Function



'=================================
' ZeroMatrix
'=================================

 Sub ZeroMatrix(Dest As D3DMATRIX)
  
  Dest.rc11 = 0
  Dest.rc12 = 0
  Dest.rc13 = 0
  Dest.rc14 = 0
  Dest.rc21 = 0
  Dest.rc22 = 0
  Dest.rc23 = 0
  Dest.rc24 = 0
  Dest.rc31 = 0
  Dest.rc32 = 0
  Dest.rc33 = 0
  Dest.rc34 = 0
  Dest.rc41 = 0
  Dest.rc42 = 0
  Dest.rc43 = 0
  Dest.rc44 = 0
  
End Sub


 Sub MatrixMult(Result As D3DMATRIX, A As D3DMATRIX, B As D3DMATRIX)
  Dim RET As D3DMATRIX
  Dim Tmp As Double
  Dim I As Integer
  Dim J As Integer
  Dim K As Integer
  
  Call ZeroMatrix(RET)
  RET.rc11 = B.rc11 * A.rc11 + B.rc21 * A.rc12 + B.rc31 * A.rc13 + B.rc41 * A.rc14
  RET.rc12 = B.rc12 * A.rc11 + B.rc22 * A.rc12 + B.rc32 * A.rc13 + B.rc42 * A.rc14
  RET.rc13 = B.rc13 * A.rc11 + B.rc23 * A.rc12 + B.rc33 * A.rc13 + B.rc43 * A.rc14
  RET.rc14 = B.rc14 * A.rc11 + B.rc24 * A.rc12 + B.rc34 * A.rc13 + B.rc44 * A.rc14
  RET.rc21 = B.rc11 * A.rc21 + B.rc21 * A.rc22 + B.rc31 * A.rc23 + B.rc41 * A.rc24
  RET.rc22 = B.rc12 * A.rc21 + B.rc22 * A.rc22 + B.rc32 * A.rc23 + B.rc42 * A.rc24
  RET.rc23 = B.rc13 * A.rc21 + B.rc23 * A.rc22 + B.rc33 * A.rc23 + B.rc43 * A.rc24
  RET.rc24 = B.rc14 * A.rc21 + B.rc24 * A.rc22 + B.rc34 * A.rc23 + B.rc44 * A.rc24
  RET.rc31 = B.rc11 * A.rc31 + B.rc21 * A.rc32 + B.rc31 * A.rc33 + B.rc41 * A.rc34
  RET.rc32 = B.rc12 * A.rc31 + B.rc22 * A.rc32 + B.rc32 * A.rc33 + B.rc42 * A.rc34
  RET.rc33 = B.rc13 * A.rc31 + B.rc23 * A.rc32 + B.rc33 * A.rc33 + B.rc43 * A.rc34
  RET.rc34 = B.rc14 * A.rc31 + B.rc24 * A.rc32 + B.rc34 * A.rc33 + B.rc44 * A.rc34
  RET.rc41 = B.rc11 * A.rc41 + B.rc21 * A.rc42 + B.rc31 * A.rc43 + B.rc41 * A.rc44
  RET.rc42 = B.rc12 * A.rc41 + B.rc22 * A.rc42 + B.rc32 * A.rc43 + B.rc42 * A.rc44
  RET.rc43 = B.rc13 * A.rc41 + B.rc23 * A.rc42 + B.rc33 * A.rc43 + B.rc43 * A.rc44
  RET.rc44 = B.rc14 * A.rc41 + B.rc24 * A.rc42 + B.rc34 * A.rc43 + B.rc44 * A.rc44
  Result = RET
End Sub

 Function RetMatrixMult(A As D3DMATRIX, B As D3DMATRIX) As D3DMATRIX
  Dim RET As D3DMATRIX
  RET.rc11 = B.rc11 * A.rc11 + B.rc21 * A.rc12 + B.rc31 * A.rc13 + B.rc41 * A.rc14
  RET.rc12 = B.rc12 * A.rc11 + B.rc22 * A.rc12 + B.rc32 * A.rc13 + B.rc42 * A.rc14
  RET.rc13 = B.rc13 * A.rc11 + B.rc23 * A.rc12 + B.rc33 * A.rc13 + B.rc43 * A.rc14
  RET.rc14 = B.rc14 * A.rc11 + B.rc24 * A.rc12 + B.rc34 * A.rc13 + B.rc44 * A.rc14
  RET.rc21 = B.rc11 * A.rc21 + B.rc21 * A.rc22 + B.rc31 * A.rc23 + B.rc41 * A.rc24
  RET.rc22 = B.rc12 * A.rc21 + B.rc22 * A.rc22 + B.rc32 * A.rc23 + B.rc42 * A.rc24
  RET.rc23 = B.rc13 * A.rc21 + B.rc23 * A.rc22 + B.rc33 * A.rc23 + B.rc43 * A.rc24
  RET.rc24 = B.rc14 * A.rc21 + B.rc24 * A.rc22 + B.rc34 * A.rc23 + B.rc44 * A.rc24
  RET.rc31 = B.rc11 * A.rc31 + B.rc21 * A.rc32 + B.rc31 * A.rc33 + B.rc41 * A.rc34
  RET.rc32 = B.rc12 * A.rc31 + B.rc22 * A.rc32 + B.rc32 * A.rc33 + B.rc42 * A.rc34
  RET.rc33 = B.rc13 * A.rc31 + B.rc23 * A.rc32 + B.rc33 * A.rc33 + B.rc43 * A.rc34
  RET.rc34 = B.rc14 * A.rc31 + B.rc24 * A.rc32 + B.rc34 * A.rc33 + B.rc44 * A.rc34
  RET.rc41 = B.rc11 * A.rc41 + B.rc21 * A.rc42 + B.rc31 * A.rc43 + B.rc41 * A.rc44
  RET.rc42 = B.rc12 * A.rc41 + B.rc22 * A.rc42 + B.rc32 * A.rc43 + B.rc42 * A.rc44
  RET.rc43 = B.rc13 * A.rc41 + B.rc23 * A.rc42 + B.rc33 * A.rc43 + B.rc43 * A.rc44
  RET.rc44 = B.rc14 * A.rc41 + B.rc24 * A.rc42 + B.rc34 * A.rc43 + B.rc44 * A.rc44
  RetMatrixMult = RET
End Function

'=================================
' TranslateMatrix
'=================================
' used to position an object

 Sub TranslateMatrix(M As D3DMATRIX, v As D3DVECTOR)
  Call IdentityMatrix(M)
  M.rc41 = v.X
  M.rc42 = v.Y
  M.rc43 = v.Z
End Sub

 Function RetTranslateMatrix(v As D3DVECTOR) As D3DMATRIX
  Dim M As D3DMATRIX
  Call IdentityMatrix(M)
  M.rc41 = v.X
  M.rc42 = v.Y
  M.rc43 = v.Z
  RetTranslateMatrix = M
End Function


'=================================
' RotateXMatrix
'=================================
' rotate an object about x axis rad radians

 Sub RotateXMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc22 = cosine
  RET.rc33 = cosine
  RET.rc23 = -sine
  RET.rc32 = sine
End Sub

 Function RetRotateXMatrix(rads As Single) As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  Dim RET As D3DMATRIX
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc22 = cosine
  RET.rc33 = cosine
  RET.rc23 = -sine
  RET.rc32 = sine
  RetRotateXMatrix = RET
End Function

'=================================
' RotateYMatrix
'=================================
' rotate an object about y axis rad radians

 Sub RotateYMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc33 = cosine
  RET.rc13 = sine
  RET.rc31 = -sine
End Sub

 Function RetRotateYMatrix(rads As Single) As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  Dim RET As D3DMATRIX
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc33 = cosine
  RET.rc13 = sine
  RET.rc31 = -sine
  RetRotateYMatrix = RET
End Function

'=================================
' RotateZMatrix
'=================================
' rotate an object about z axis rad radians

 Sub RotateZMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc22 = cosine
  RET.rc12 = -sine
  RET.rc21 = sine
End Sub

 Function RetRotateZMatrix(rads As Single) As D3DMATRIX
  Dim RET As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc22 = cosine
  RET.rc12 = -sine
  RET.rc21 = sine
  RetRotateZMatrix = RET
End Function


