VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_SkyBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False





Public Enum Johna_SkyBOXPosition
   Johna_SKY_LEFT = &H0
   Johna_SKY_RIGHT = &H1
   Johna_SKY_TOP = &H2
   Johna_SKY_BOTTOM = &H3
   Johna_SKY_BACK = &H4
   Johna_SKY_FRONT = &H5


End Enum


Private SKY_TEX(5) As DirectDrawSurface7
Private SKYvertices() As D3DVERTEX
Private SkyScale As D3DVECTOR


Private Type VerTEX_PARAM
  vPosition As D3DVECTOR
  Vscal As D3DVECTOR
  Vrotate As D3DVECTOR
  

End Type

Private Sky As VerTEX_PARAM



Sub Init_SkyBox(DXengine As johna_DX7, ScaleX, ScaleY, ScaleZ)
CreateCubeEX SKYvertices(), Vector(ScaleX, ScaleY, ScaleZ)
Sky.Vscal = Vector(ScaleX, ScaleY, ScaleZ)

End Sub

Sub Add_SkyBOX(JOX As johna_DX7, Position As Johna_SkyBOXPosition, TexTurefile As String)

    Set SKY_TEX(Position) = JOX.CreateTextureEX(TexTurefile, 256, 256)


End Sub









Sub RenderSky(Engine As johna_DX7)

Dim Clock As Long
Clock = Engine.D3D_DEV.GetRenderState(D3DRENDERSTATE_CULLMODE)
'Engine.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE, D3DCULL_CW


Dim Clamp1 As Long

Dim Clamp2 As Long
  Engine.Set_Light 1
   
    'get default
    Clamp1 = Engine.D3D_DEV.GetTextureStageState(0, D3DTSS_ADDRESSU)
    Clamp2 = Engine.D3D_DEV.GetTextureStageState(0, D3DTSS_ADDRESSV)
    
    
    Call Engine.D3D_DEV.SetTextureStageState(0, D3DTSS_ADDRESSU, D3DTADDRESS_CLAMP)
    Call Engine.D3D_DEV.SetTextureStageState(0, D3DTSS_ADDRESSV, D3DTADDRESS_CLAMP)

Dim matView As D3DMATRIX, matViewSave As D3DMATRIX

Engine.D3D_DEV.GetTransform D3DTRANSFORMSTATE_VIEW, matViewSave
    matView = matViewSave
    matView.rc41 = 0: matView.rc42 = 0: matView.rc43 = 0
    Engine.D3D_DEV.SetTransform D3DTRANSFORMSTATE_VIEW, matView

Engine.OBJECT_scale Sky.Vscal.X, Sky.Vscal.Y, Sky.Vscal.Z


    'front
    Engine.D3D_DEV.SetTexture 0, SKY_TEX(Johna_SKY_FRONT)
    Call Engine.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SKYvertices(4), _
         4, 0)
    
    'back
    Engine.D3D_DEV.SetTexture 0, SKY_TEX(Johna_SKY_BACK)
    Call Engine.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SKYvertices(0), _
         4, D3DDP_DEFAULT)
         
    ' Draw the top and bottom faces of the cube using texture 2
   
   Engine.D3D_DEV.SetTexture 0, SKY_TEX(Johna_SKY_TOP)
    Call Engine.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SKYvertices(8), _
         4, D3DDP_DEFAULT)
    Engine.D3D_DEV.SetTexture 0, SKY_TEX(Johna_SKY_BOTTOM)
    Call Engine.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SKYvertices(12), _
         4, D3DDP_DEFAULT)
   
    ' Draw the left and right faces of the cube using texture 3
    Engine.D3D_DEV.SetTexture 0, SKY_TEX(Johna_SKY_RIGHT)
    Call Engine.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SKYvertices(16), _
         4, D3DDP_DEFAULT)
    Engine.D3D_DEV.SetTexture 0, SKY_TEX(Johna_SKY_LEFT)
    Call Engine.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SKYvertices(20), _
         4, D3DDP_DEFAULT)


'restore view,Uv
Call Engine.D3D_DEV.SetTextureStageState(0, D3DTSS_ADDRESSU, Clamp1)
Call Engine.D3D_DEV.SetTextureStageState(0, D3DTSS_ADDRESSV, Clamp2)

Engine.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE, Clock

    Engine.D3D_DEV.SetTransform D3DTRANSFORMSTATE_VIEW, matViewSave

Engine.CLearMATRIX
End Sub





Private Sub CreateCubeEX(Vertices() As D3DVERTEX, Vsize As D3DVECTOR, Optional TileX = 1, Optional TileY = 1)
     ReDim Preserve Vertices(23)
      Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, Sy, Sz
     Dim DXXz As New DirectX7
     Sx = Vsize.X / 2
     Sy = Vsize.Y / 2
     Sz = Vsize.Z / 2
     
     V1 = Vector(-Sx, -Sy, -Sz)
     V2 = Vector(Sx, Sy, Sz)
           
    ' Create vertices describing the front face of the cube.
    DXXz.CreateD3DVertex -1#, -1#, 1#, 0, 0, -1, 0, 1, Vertices(0)
    DXXz.CreateD3DVertex -1#, 1#, 1#, 0, 0, -1, 0, 0, Vertices(1)
    DXXz.CreateD3DVertex 1#, -1#, 1#, 0, 0, -1, 1, 1, Vertices(2)
    DXXz.CreateD3DVertex 1#, 1#, 1#, 0, 0, -1, 1, 0, Vertices(3)
        
    ' Create vertices describing the back face of the cube.
    DXXz.CreateD3DVertex 1, -1, -1, 0, 0, 1, 0, 1, Vertices(4)
    DXXz.CreateD3DVertex 1, 1, -1, 0, 0, 1, 0, 0, Vertices(5)
    DXXz.CreateD3DVertex -1, -1, -1, 0, 0, 1, 1, 1, Vertices(6)
    DXXz.CreateD3DVertex -1, 1, -1, 0, 0, 1, 1, 0, Vertices(7)
        
    ' Create vertices describing the top face of the cube.
    DXXz.CreateD3DVertex -1, 1, 1, 0, -1, 0, 0, 1, Vertices(8)
    DXXz.CreateD3DVertex -1, 1, -1, 0, -1, 0, 0, 0, Vertices(9)
    DXXz.CreateD3DVertex 1, 1, 1, 0, -1, 0, 1, 1, Vertices(10)
    DXXz.CreateD3DVertex 1, 1, -1, 0, -1, 0, 1, 0, Vertices(11)
        
    ' Create vertices describing the bottom face of the cube.
    DXXz.CreateD3DVertex -1, -1, -1, 0, -1, 0, 0, 1, Vertices(12)
    DXXz.CreateD3DVertex -1, -1, 1, 0, -1, 0, 0, 0, Vertices(13)
    DXXz.CreateD3DVertex 1, -1, -1, 0, -1, 0, 1, 1, Vertices(14)
    DXXz.CreateD3DVertex 1, -1, 1, 0, -1, 0, 1, 0, Vertices(15)
        
    ' Create vertices describing the right face of the cube.
    DXXz.CreateD3DVertex 1, -1, 1, 1, 0, 0, 0, 1, Vertices(16)
    DXXz.CreateD3DVertex 1, 1, 1, 1, 0, 0, 0, 0, Vertices(17)
    DXXz.CreateD3DVertex 1, -1, -1, 1, 0, 0, 1, 1, Vertices(18)
    DXXz.CreateD3DVertex 1, 1, -1, 1, 0, 0, 1, 0, Vertices(19)
        
    ' Create vertices describing the left face of the cube.
    DXXz.CreateD3DVertex -1, -1, -1, -1, 0, 0, 0, 1, Vertices(20)
    DXXz.CreateD3DVertex -1, 1, -1, -1, 0, 0, 0, 0, Vertices(21)
    DXXz.CreateD3DVertex -1, -1, 1, -1, 0, 0, 1, 1, Vertices(22)
    DXXz.CreateD3DVertex -1, 1, 1, -1, 0, 0, 1, 0, Vertices(23)
    
End Sub







'position orientation
Public Property Get vPosition() As D3DVECTOR
      vPosition = Sky.vPosition
End Property

Public Property Let vPosition(vNew As D3DVECTOR)
      Sky.vPosition = vNew
      'ComputeBOX
End Property


Public Property Get Vrotation() As D3DVECTOR
      Vrotation = Sky.Vrotate
      
End Property

Public Property Let Vrotation(vNew As D3DVECTOR)
      Sky.Vrotate = vNew
      
End Property


Public Property Get VScale() As D3DVECTOR
      VScale = Sky.Vscal
      
End Property

Public Property Let VScale(vNew As D3DVECTOR)
      Sky.Vscal = vNew
      
End Property


Sub Set_Position(X, Y, Z)
  Sky.vPosition.X = X
  Sky.vPosition.Y = Y
  Sky.vPosition.Z = Z
  
End Sub

Sub Set_Rotation(X, Y, Z)
  Sky.Vrotate.X = X
  Sky.Vrotate.Y = Y
  Sky.Vrotate.Z = Z
  
End Sub

Sub Set_Scale(X, Y, Z)
  Sky.Vscal.X = X
  Sky.Vscal.Y = Y
  Sky.Vscal.Z = Z
  
End Sub
