VERSION 5.00
Begin VB.Form DeviceDIALOGUE 
   BackColor       =   &H80000008&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Select DRIVERS"
   ClientHeight    =   4155
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6750
   Icon            =   "ENUM.frx":0000
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4155
   ScaleWidth      =   6750
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      BackColor       =   &H00C0C000&
      Caption         =   "Choose your D3D device"
      Height          =   735
      Left            =   2880
      TabIndex        =   7
      Top             =   2040
      Width           =   3735
      Begin VB.ComboBox Combo2 
         Height          =   315
         Left            =   240
         TabIndex        =   8
         Text            =   "D3d Device Available"
         Top             =   240
         Width           =   3375
      End
   End
   Begin VB.Frame Frame2 
      BackColor       =   &H00C0C000&
      Caption         =   "Choose your displaymode"
      Height          =   735
      Left            =   2880
      TabIndex        =   5
      Top             =   1080
      Width           =   3735
      Begin VB.ComboBox Combo3 
         Height          =   315
         Left            =   240
         TabIndex        =   6
         Text            =   "DisplayModes Available"
         Top             =   240
         Width           =   3375
      End
   End
   Begin VB.Frame Frame1 
      BackColor       =   &H00C0C000&
      Caption         =   "Choose your GFX card"
      Height          =   855
      Left            =   2880
      TabIndex        =   3
      Top             =   120
      Width           =   3735
      Begin VB.ComboBox Combo1 
         Height          =   315
         Left            =   240
         TabIndex        =   4
         Text            =   "DirectDraw Device Available"
         Top             =   360
         Width           =   3375
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3840
      TabIndex        =   2
      Top             =   3600
      Width           =   1695
   End
   Begin VB.CheckBox Check1 
      BackColor       =   &H00C0C000&
      Caption         =   "Use Windows Desktop displaymode"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   2880
      Width           =   3855
   End
   Begin VB.CommandButton Command1 
      BackColor       =   &H00C0C000&
      Caption         =   "OK"
      Height          =   375
      Left            =   360
      MaskColor       =   &H00FFFFC0&
      TabIndex        =   0
      Top             =   3600
      Width           =   1575
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   2415
      Left            =   120
      Picture         =   "ENUM.frx":08CA
      Stretch         =   -1  'True
      Top             =   240
      Width           =   2655
   End
End
Attribute VB_Name = "DeviceDIALOGUE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'--------------------------------------------------------------------------------
'    Component  : DeviceDIALOGUE
'    Project    : Johna_DX7 engine
'
'    Description: class for enumeration
'
'    Modified   :2/10/01
'--------------------------------------------------------------------------------

Dim D3DEnum As Direct3DEnumDevices


Dim DDEnum As DirectDrawEnum

Dim DDsD() As DDSURFACEDESC2


Private Type Tguid
  Window_Width As Integer
  Window_Height As Integer
  BBP As Byte
  Ddraw_GUID As String
  D3DDEVICE_Guid As String
  Use_Windowed As Boolean
  LpHandle As Long
End Type

Private Type DisplayModeDesc
    width As Long
    Height As Long
    Bpp As Byte
End Type
Dim DisplayModes() As DisplayModeDesc 'note the fact that I haven't
Dim DisplayModesEnum As DirectDrawEnumModes

Private P_GUID As Tguid
Private C_JOX As johna_DX7


Public Sub INIT_enum(ByRef K_JOX As johna_DX7, LpHandle As Long)

'Load Me

Set C_JOX = K_JOX
P_GUID.LpHandle = LpHandle


'
'
'enum DX directdraw driver first
'===============

Set DDEnum = C_JOX.DX_7.GetDDEnum()
Dim I
 For I = 1 To DDEnum.GetCount()
       Combo1.AddItem DDEnum.GetDescription(I)
    Next I
  
  Combo1.ListIndex = 0
  
  
'
'
'enum D3Ddevice driver
'===============
  
  

Set C_JOX.ddraw = C_JOX.DX_7.DirectDrawCreate("")
Set C_JOX.D3d = C_JOX.ddraw.GetDirect3D()

Set D3DEnum = C_JOX.D3d.GetDevicesEnum()

For I = 1 To D3DEnum.GetCount
    Combo2.AddItem D3DEnum.GetDescription(I)



Next I

Combo2.ListIndex = Combo2.ListCount - 2


'
'
'enum available display mode
'===============


 'These two lines can also be seen in the Init sub. This time
    'it doesn't go to fullscreen mode
    Set C_JOX.ddraw = C_JOX.DX_7.DirectDrawCreate("")
    C_JOX.ddraw.SetCooperativeLevel Me.hwnd, DDSCL_NORMAL
    
    Dim DDSD2 As DDSURFACEDESC2
    'Create the Enumeration object
    Set DisplayModesEnum = C_JOX.ddraw.GetDisplayModesEnum(0, DDSD2)
    'Remember the array that wasn't defined? At this point
    'we set the size of the array.
    ReDim DisplayModes(DisplayModesEnum.GetCount()) As DisplayModeDesc
    ReDim DDsD(DisplayModesEnum.GetCount()) As DDSURFACEDESC2
    
    'This loop runs through the display modes, retrieving the data.
    'Height/Width/BPP aren't the only things that you can retrieve here....
    For I = 1 To DisplayModesEnum.GetCount()
        DisplayModesEnum.GetItem I, DDsD(I)
        Combo3.AddItem CStr(DDsD(I).lWidth) & "x" & CStr(DDsD(I).lheight) & " " & CStr(DDsD(I).ddpfPixelFormat.lRGBBitCount) & "bpp"
        Combo3.Text = CStr(DDsD(I).lWidth) & "x" & CStr(DDsD(I).lheight) & " " & CStr(DDsD(I).ddpfPixelFormat.lRGBBitCount) & "bpp"
        'This fills out the data structure to include information
        'on the current display mode.
        DisplayModes(I).Height = DDsD(I).lheight
        DisplayModes(I).width = DDsD(I).lWidth
        DisplayModes(I).Bpp = DDsD(I).ddpfPixelFormat.lRGBBitCount
    Next I


For I = 0 To Combo3.ListCount - 1

  If InStr(Combo3.List(I), "640x480 16bpp") Then Exit For
Next I

Combo3.ListIndex = I


If Not C_JOX.D3d Is Nothing Then
  
    Set C_JOX.D3d = Nothing
End If

If Not C_JOX.ddraw Is Nothing Then
  
    Set C_JOX.ddraw = Nothing
End If

Me.Show vbModal
Me.Refresh

End Sub

Private Sub Check1_Click()
  
  If P_GUID.Use_Windowed Then P_GUID.Use_Windowed = False Else P_GUID.Use_Windowed = True
  
  If P_GUID.Use_Windowed Then Combo3.Enabled = False Else Combo3.Enabled = True
  
End Sub

Private Sub Combo1_Change()
   
   P_GUID.Ddraw_GUID = DDEnum.GetGuid(Combo1.ListIndex + 1)
End Sub

Private Sub Combo2_Change()
   
   P_GUID.D3DDEVICE_Guid = D3DEnum.GetGuid(Combo2.ListIndex + 1)
End Sub

Private Sub Combo1_Click()
 Combo1_Change
End Sub

Private Sub Combo2_Click()
 Combo2_Change
End Sub


Private Sub Combo3_click()
  P_GUID.BBP = DDsD(Combo3.ListIndex + 1).ddpfPixelFormat.lRGBBitCount
  P_GUID.Window_Width = DDsD(Combo3.ListIndex + 1).lWidth
  P_GUID.Window_Height = DDsD(Combo3.ListIndex + 1).lheight
  
End Sub

Private Sub Command1_Click()
  Dim ST As String
  ST = "you chose  " + Chr(10)
  ST = ST + "Ddraw device = " + P_GUID.Ddraw_GUID + Chr(10)
  ST = ST + "D3d Device =" + P_GUID.D3DDEVICE_Guid + Chr(10)
  ST = ST + "Window Width =" + Str(P_GUID.Window_Width) + Chr(10)
  ST = ST + "Window Height =" + Str(P_GUID.Window_Height) + Chr(10)
  
  
  
  
  'MsgBox st, vbDefaultButton2
  
  
  Me.Hide
  C_JOX.Initialize_EngineEX P_GUID.LpHandle, P_GUID.Ddraw_GUID, P_GUID.D3DDEVICE_Guid, P_GUID.Use_Windowed, P_GUID.Window_Width, P_GUID.Window_Height, P_GUID.BBP
  
  Unload Me
  
End Sub

Private Sub Command2_Click()
 End
 Set C_JOX = Nothing
End Sub

Private Sub Form_Load()
Check1.VALUE = 1
End Sub
